#include "serial.h"
#include "iodefine.h"

#define SCI_9600_BPS (64)
int serial_init( void )
{
	int i;
	IO.PMR1.BIT.TXD = 1;			// port1̖߂(VAƂĎgp)
	
	SCI3.SCR3.BYTE	= 0;
	SCI3.SMR.BYTE	= 0;			// all0 8bit, N, 1ɂȂ
	SCI3.BRR		= SCI_9600_BPS;	// 20MHz̏ꍇ́A64w9600bpsɂȂ
	
	// ƃX[v
	for ( i = 0; i < 10000; i++ ) /* nop */;
	
	SCI3.SCR3.BYTE = 0x30;			// RxEnable and TxEnable
	
	SCI3.SSR.BYTE = 0x00;
}

int serial_is_send_enable( void )
{
	if ( SCI3.SSR.BIT.TDRE == 1 ) {
		// Txempty -> M\
		return 0;
	}
	
	// MNG
	return 1;
}


int serial_send_byte( unsigned char c )
{
	// M\ɂȂ܂ő҂
	while( 1 ) {
		// M\`FbN
		if ( serial_is_send_enable() == 0 ) {
			break;
		}
	}
	
	// 1byteM
	SCI3.TDR  = c;
	
	// TRRẼrbg𗎂Ƃ(1:not empty)AMv
	SCI3.SSR.BIT.TDRE = 1;
}
